#ifndef LOGGER_H
#define LOGGER_H

#include <iostream>
#include <map>

class Logger
{
public:
	enum LogLevel
	{
		Debug,
		Info,
		Error,
		Critical
	};

private:
	explicit Logger(std::ostream& log_stream);
	Logger();
	Logger(const Logger&);
	Logger& operator=(const Logger&);
	
public:
	std::ostream& log(LogLevel level);
	static Logger& instance();
	
private:
	std::ostream& m_stream;
};

#define LOG_ERR(X) Logger::instance().log(Logger::Error)<<X<<std::endl
#define LOG_DBG(X) Logger::instance().log(Logger::Debug)<<X<<std::endl
#define LOG_INF(X) Logger::instance().log(Logger::Info)<<X<<std::endl
#define LOG_CRITICAL(X) Logger::instance().log(Logger::Critical)<<X<<std::endl

#endif //LOGGER_H
