#include "virtual_machine.h"
#include "no_debugger.h"
#include "interactive_debugger.h"
#include "svm02.h"
#include <cstring>

template <class Tp, class Td>
void exec(const char* file)
{
		VirtualMachine<Tp, Td> vm;
		vm.load(file);
		vm.run();	
}

int main(int argc, char **argv)
{
	if(argc <= 1)
	{
                std::cout << "SVM 0.2\nUsage: svm [filename] [options]\nOptions:\n-d -- enable interactive debugging\n";
	}
	else
	{
		if(argc >= 3 && !strcmp(argv[2], "-d")) exec<SVM02, InteractiveDebugger>(argv[1]);
		else exec<SVM02, NoDebugger>(argv[1]);
	}
	return 0;
}
