#ifndef INSTRUCTION_CODES_H
#define INSTRUCTION_CODES_H

//I/O
#define IN     -1
#define OUT    -2

//Arithmetic
#define ADD    -3
#define SUB    -4
#define MUL    -5
#define DIV    -6
#define MOD    -7
#define NEG    -8
#define INC    -9
#define DEC    -10

//Bitwise operations
#define AND    -11
#define OR     -12
#define NOT    -13
#define XOR    -14
#define SHL    -15
#define SHR    -16

//Stack
#define POP    -17
#define DUP    -18
#define SWP    -19
#define OVR    -20

//Memory
#define LOAD   -21
#define STOR   -22

//Jumps
#define JMP    -23
#define JE     -24
#define JNE    -25
#define JG     -26
#define JGE    -27
#define JL     -28
#define JLE    -29

#define NOP    -30
#define HALT   -31

//Flags
#define RF     -101
#define CRF    -102

#endif // INSTRUCTION_CODES_H
