#include "logger.h"

Logger::Logger(std::ostream& log_stream):m_stream(log_stream){}

std::ostream& Logger::log(LogLevel level)
{
	switch(level)
	{
	case Error:
			m_stream << "ERROR: ";
			break;
			
	case Info:
		m_stream << "INFO: ";
		break;
		
	case Critical:
		m_stream << "FATAL ERROR: ";
		break;
	}
	return m_stream;
}

Logger& Logger::instance()
{
	static Logger l(std::cerr);
	return l;
}