//SVM Assembler
#include <iostream>
#include <fstream>
#include <stdexcept>
#include "compiler.h"
#include "logger.h"

int main(int argc, char* argv[])
{
	if(argc < 3)
	{
		std::cout << "SVM assembler 0.1\nUsage: svmasm [infile] [outfile]\n";
		return 0;
	}
	std::ifstream in(argv[1]);
	std::ofstream out(argv[2], std::ios::binary);
	
	try
	{
		Compiler compiler; //Create and initialize a new compiler object
	
		//We read input from stdin and write the generated code to stdout
		compiler.processInput(in);
		compiler.dumpCode(out);
	}
	catch(const std::runtime_error&)
	{
		LOG_INF("Exception occured, dying");
	}
	return 0;
}